<template>
  <el-dialog v-model="openDialog" :before-close="handleClose" :width="width">
    <div class="text-base">
      <h3 class="text-xl font-bold">{{ project.name }}</h3>
      <p class="text-right">
        <small><b>ปีงบประมาณ</b> {{ project.budget_year.year }}</small>
      </p>
      <b class="text-lg">ยุทธศาสตร์</b>
      <p>
        ยุทธศาสตร์ที่ {{ project.stargic.number }} :
        {{ project.stargic.name }}
      </p>
      <b class="text-lg">ผู้รับผิดชอบโครงการ</b>
      <ol class="list-decimal pl-4">
        <li v-for="owner in project.owners" :key="owner.id">
          {{ owner.title }}{{ owner.firstname }} &nbsp;{{ owner.lastname }}
        </li>
      </ol>
      <b class="text-lg">ระยะเวลาดำเนินการ</b>
      <p>
        {{ project.project_start }} ถึง
        {{ project.project_end }}
      </p>
      <b class="text-lg">วัตถุประสงค์</b>
      <ol class="list-decimal pl-4">
        {{
          project.objective_id
        }}
        <li v-for="objective in project.objectives" :key="objective.id">
          {{ objective.detail }}
        </li>
      </ol>
      <b class="text-lg">พื้นที่ดำเนินงาน</b>
      <ol class="list-decimal pl-4">
        <li v-for="area in project.areas" :key="area.id">
          {{ area.title }}{{ area.firstname }} &nbsp;{{ area.address }}
        </li>
      </ol>
      <b class="text-lg">งบประมาณทั้งหมด</b>
      <ul>
        <li v-for="budget in project.budgets" :key="budget.id">
          <span>{{ budget.detail }} </span> &nbsp;
          <span>{{ budget.number }} บาท</span>
        </li>
      </ul>
      <div>
        <div
          ref="mapDiv"
          style="width: 100%; height: 50vh"
          v-if="project.areas[0]"
        />
      </div>
    </div>
    <template #footer>
      <span class="dialog-footer">
        <button
          @click="handleClose"
          class="
            transition
            duration-200
            ease-in-out
            transform
            hover:-translate-y-1
            px-3
            py-1
            bg-gradient-to-r
            from-red-600
            to-red-400
            rounded-md
            text-white
            shadow-md
            mr-2
            focus:outline-none
          "
          type="button"
        >
          ปิด
        </button>
      </span>
    </template>
  </el-dialog>
</template>

<script>
import { GOOGLE_MAPS_API_KEY } from "@/Pages/ProjectMap.vue";
import { Loader } from "@googlemaps/js-api-loader";
import { computed, defineComponent, onMounted, ref, toRefs, watch } from "vue";

export default defineComponent({
  props: {
    open: {
      type: Boolean,
      required: true,
    },
    project: {
      type: Object,
      required: true,
    },
    typWindow: String,
    windowWidth: Number,
  },
  setup(props, { emit }) {
    //   model
    const { open, project, typWindow, windowWidth } = toRefs(props);
    const openDialog = ref(false);
    const width = computed(() => {
      switch (typWindow.value) {
        case "sm":
          return "95%";
        case "md":
          return "75%";
        case "lg":
          return "75%";
        case "xl":
          return "65%";
        default:
          return "45%";
      }
    });

    const currPos = computed(() => ({
      lat: project.value.areas[0]?.lat,
      lng: project.value.areas[0]?.long,
    }));
    const loader = new Loader({ apiKey: GOOGLE_MAPS_API_KEY });
    const mapDiv = ref(null);
    const map = ref(null);
    const infowindow = ref(null);

    watch(open, async (value, prevValue) => {
      openDialog.value = value;
      if (value && currPos.value.lat) {
        await loader.load();
        map.value = new google.maps.Map(mapDiv.value, {
          center: currPos.value,
          zoom: 9,
        });
        infowindow.value = new google.maps.InfoWindow();
        project.value.areas.forEach((area) => {
          const myLatlng = new google.maps.LatLng(area.lat, area.long);
          const mark = new google.maps.Marker({
            position: myLatlng,
            map: map.value,
            title: area.address,
          });

          ((mark, area) => {
            google.maps.event.addListener(mark, "click", () => {
              infowindow.value.setContent(
                "<div style = 'width:200px;min-height:40px'>" +
                  area.address +
                  "</div>"
              );
              infowindow.value.open({
                shouldFocus: false,
                anchor: mark,
              });
            });
          })(mark, area);
        });
      }
    });
    // form

    const handleClose = () => {
      emit("close");
      openDialog.value = false;
    };
    return {
      typWindow,
      windowWidth,
      project,
      openDialog,
      handleClose,
      width,
      mapDiv,
    };
  },
});
</script>
